/*
 *  SokoBan, a Sokoban game.
 *  Copyright (C) 2008  Colomban Wendling <ban@herbesfolles.org>
 * 
 *  This program is free software: you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation, either version 3 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program.  If not, see <http://www.gnu.org/licenses/>.
 *
 */


#ifndef __SOKOBAN_H__
#define __SOKOBAN_H__


#include <stdio.h>

#include "map.h"


#ifndef DATADIR
   #define DATADIR "data/"
#endif
#ifndef LOCALEDIR
   #define LOCALEDIR "locale/"
#endif

#define SOKOBAN_NAME "SokoBan 2"
#define SOKOBAN_PACKAGE "sokoban2"
#define SOKOBAN_VERSION 0.1
#define SOKOBAN_STRVERSION "0.1"

#define WIN_WIDTH  (MAP_WIDTH  * MAP_BLOCKSIZE)
#define WIN_HEIGHT (MAP_HEIGHT * MAP_BLOCKSIZE)
#define WIN_DEPTH 32


/* end of line */
#ifndef EOL
#  if defined (__WIN32__)
#     define EOL "\r\n"
#  elif defined (__MACOS__)
#     define EOL "\r"
#  else
#     define EOL "\n"
#  endif
#endif


#define memalloc_errormsg() \
   fprintf(stderr, "** Failed to allocate memory at %s:%d %s\n", \
                   __FILE__, __LINE__, __FUNCTION__)

#ifdef DEBUG
#define trace() \
   {fprintf(stdout, "** %s:%d: entering %s\n", \
                   __FILE__, __LINE__, __FUNCTION__); \
    fflush (stdout);}
#else
#define trace()
#endif

#define valofp(v) \
   printf ("%s:%p\n", #v, v)


typedef enum _MyBool MyBool;

enum _MyBool
{
   FALSE = 0, /**< Boolean's false */
   TRUE  = 1  /**< Boolean's true */
};


#endif /* guard */
